# Edit Audio Settings of a Guest
use strict;
use warnings;
our (%gui, %signal, %hostspec, %ETruth, %EAudioDriverType, %EAudioControllerType, %vmc);

sub setup_edit_dialog_audio() {
    &busy_window($gui{dialogEdit}, 0, 'watch');
    $gui{comboboxEditAudioDriver}->signal_handler_block($signal{audiodrv});
    $gui{comboboxEditAudioCtr}->signal_handler_block($signal{audioctr});
    &clr_list($gui{liststoreEditAudioDriver}, $gui{liststoreEditAudioCtr});
    $gui{checkbuttonEditAudioEnable}->set_active($ETruth{IAudioAdapter_getEnabled($vmc{IAudioAdapter})});
    $gui{tableEditAudio}->set_sensitive($gui{checkbuttonEditAudioEnable}->get_active()); # Ghost/Unghost other widgets based on audio enabled

    foreach my $driver (sort(keys %EAudioDriverType)) {
        if ($hostspec{os} =~ m/${EAudioDriverType{$driver}{os}}/ or $EAudioDriverType{$driver}{os} eq 'All') {
            my $iter = &addrow_list($gui{liststoreEditAudioDriver}, 0, $EAudioDriverType{$driver}{desc}, 1, $driver);
            $gui{comboboxEditAudioDriver}->set_active_iter($iter) if ($driver eq IAudioAdapter_getAudioDriver($vmc{IAudioAdapter}));
        }
    }

    foreach my $ctr (sort(keys %EAudioControllerType)) {
        my $iter = &addrow_list($gui{liststoreEditAudioCtr}, 0, $EAudioControllerType{$ctr}, 1, $ctr);
        $gui{comboboxEditAudioCtr}->set_active_iter($iter) if ($ctr eq IAudioAdapter_getAudioController($vmc{IAudioAdapter}));
    }

    $gui{comboboxEditAudioDriver}->signal_handler_unblock($signal{audiodrv});
    $gui{comboboxEditAudioCtr}->signal_handler_unblock($signal{audioctr});
    &busy_window($gui{dialogEdit}, 1, undef);
}

sub audio_toggle() {
    my $state = $gui{checkbuttonEditAudioEnable}->get_active();
    IAudioAdapter_setEnabled($vmc{IAudioAdapter}, $state);
    $gui{tableEditAudio}->set_sensitive($state);
}

sub audio_ctr() {
    my $controller = &getsel_combo($gui{comboboxEditAudioCtr}, 1);
    IAudioAdapter_setAudioController($vmc{IAudioAdapter}, $controller);
}

sub audio_driver() {
    my $driver = &getsel_combo($gui{comboboxEditAudioDriver}, 1);
    IAudioAdapter_setAudioDriver($vmc{IAudioAdapter}, $driver);
}

1;