# Edit General Settings of a Guest
use strict;
use warnings;
our (%gui, %signal, %osversion, %osfamily, %vmc);

sub setup_edit_dialog_general() {
    &busy_window($gui{dialogEdit}, 0, 'watch');
    my $Name = IMachine_getName($vmc{IMachine});
    my $Osid = IMachine_getOSTypeId($vmc{IMachine});
    $gui{comboboxEditGenOSFam}->signal_handler_block($signal{famedit});
    $gui{comboboxEditGenOSVer}->signal_handler_block($signal{veredit});
    &clr_list($gui{liststoreEditGenOSFam}, $gui{liststoreEditGenOSVer});
    my $IGuestOSType = IVirtualBox_getGuestOSType($gui{websn}, $Osid);
    $gui{entryEditGenName}->set_text($Name);

    foreach my $fam (sort(keys %osfamily)) {
        my $iter = &addrow_list($gui{liststoreEditGenOSFam}, 0, $osfamily{$fam}{description}, 1, $fam, 2, $osfamily{$fam}{icon});
        $gui{comboboxEditGenOSFam}->set_active_iter($iter) if ($fam eq $$IGuestOSType{familyId});
    }

    foreach my $ver (sort(@{ $osfamily{$$IGuestOSType{familyId}}{verids} })) {
        my $iter = &addrow_list($gui{liststoreEditGenOSVer}, 0, $osversion{$ver}{description}, 1, $ver, 2, $osversion{$ver}{icon});
        $gui{comboboxEditGenOSVer}->set_active_iter($iter) if ($ver eq $$IGuestOSType{id});
    }

    my $clipmode = IMachine_getClipboardMode($vmc{IMachine});

    if ($clipmode eq 'HostToGuest') { $gui{comboboxEditGenClip}->set_active(1); }
    elsif ($clipmode eq 'GuestToHost') { $gui{comboboxEditGenClip}->set_active(2); }
    elsif ($clipmode eq 'Bidirectional') { $gui{comboboxEditGenClip}->set_active(3); }
    else { $gui{comboboxEditGenClip}->set_active(0); }

    $gui{comboboxEditGenOSFam}->signal_handler_unblock($signal{famedit});
    $gui{comboboxEditGenOSVer}->signal_handler_unblock($signal{veredit});
    &busy_window($gui{dialogEdit}, 1, undef);
}

sub gen_name() {
    my $name = $gui{entryEditGenName}->get_text();
    IMachine_setName($vmc{IMachine}, $name) if ($name);
}

sub gen_osfam() {
    my ($combofam, $combover) = @_;
    my $fam = &getsel_combo($combofam, 1);
    $combofam->signal_handler_block($signal{famedit}); # Block to avoid signal emission when changing
    $combover->signal_handler_block($signal{veredit});
    &clr_list($gui{liststoreEditGenOSVer});

    foreach my $ver (sort(@{ $osfamily{$fam}{verids} })) {
        my $iter = &addrow_list($gui{liststoreEditGenOSVer}, 0, $osversion{$ver}{description}, 1, $ver, 2, $osversion{$ver}{icon});
        $combover->set_active_iter($iter) if ($ver eq 'WindowsXP' | $ver eq 'Ubuntu' | $ver eq 'Solaris');
    }

    $combover->set_active(0) if ($combover->get_active() == -1);
    $combofam->signal_handler_unblock($signal{famedit});
    $combover->signal_handler_unblock($signal{veredit});
    $combover->signal_emit('changed'); # Force update of other fields based on OS
}

sub gen_osver() {
    my ($combover) = @_;
    my $ver = &getsel_combo($combover, 1);
    IMachine_setOSTypeId($vmc{IMachine}, $ver);
}

sub gen_clip() { IMachine_setClipboardMode($vmc{IMachine}, &getsel_combo($gui{comboboxEditGenClip}, 0)); }

1;